// Settings.cpp : implementation file
//

#include "stdafx.h"
#include "fbbw.h"
#include "Settings.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSettings dialog


CSettings::CSettings(CWnd* pParent /*=NULL*/)
	: CDialog(CSettings::IDD, pParent)
{
	m_pMainDlg = (CFbbWDlg *)pParent;

	//{{AFX_DATA_INIT(CSettings)
	m_szSignature = _T("");
	m_bBreakLine = FALSE;
	m_bJustification = FALSE;
	m_bPrefix = FALSE;
	m_bSignature = FALSE;
	m_bAnsi = FALSE;
	m_bDos = FALSE;
	//}}AFX_DATA_INIT
}


void CSettings::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSettings)
	DDX_Control(pDX, IDC_SIGNATURE, m_SignatureCtl);
	DDX_Text(pDX, IDC_SIGNATURE, m_szSignature);
	DDX_Check(pDX, IDM_BREAKLINE, m_bBreakLine);
	DDX_Check(pDX, IDM_JUSTIFICATION, m_bJustification);
	DDX_Check(pDX, IDM_PREFIX, m_bPrefix);
	DDX_Check(pDX, IDM_SIGNATURE, m_bSignature);
	DDX_Check(pDX, IDM_ANSI, m_bAnsi);
	DDX_Check(pDX, IDM_DOS, m_bDos);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSettings, CDialog)
	//{{AFX_MSG_MAP(CSettings)
	ON_BN_CLICKED(IDM_FONTS, OnFonts)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSettings message handlers

BOOL CSettings::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	if (m_pMainDlg->m_bAnsi)
		m_bAnsi = TRUE;
	else
		m_bDos = TRUE;

	m_bPrefix = m_pMainDlg->m_bPrefix;
	m_bJustification = m_pMainDlg->m_bJust;
	m_bBreakLine = m_pMainDlg->m_bBreak;

	m_bSignature = m_pMainDlg->m_bSignature;
	m_szSignature = m_pMainDlg->m_cSignature;
	m_SignatureCtl.SetFont(&m_pMainDlg->m_Font);
	
	UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSettings::OnOK() 
{
	UpdateData(TRUE);

	m_pMainDlg->SetAnsi(m_bAnsi);

	m_pMainDlg->SetPrefix(m_bPrefix);
	m_pMainDlg->SetJustification(m_bJustification);
	m_pMainDlg->SetBreakline(m_bBreakLine);

	m_pMainDlg->SetSignature(m_bSignature, m_szSignature);
	
	CDialog::OnOK();
}

void CSettings::OnFonts() 
{
	m_pMainDlg->SetFont();
	m_SignatureCtl.SetFont(&m_pMainDlg->m_Font);
}
